annts <-
function(data,varlag=c(1,0),k1,ntiter=100,outfile=NULL)
{
#initialisation
require(MASS)
require(nnet)
ANN<-list(title="multiple (auto)-regression by ANN method")
iter=1:ntiter
nstep=floor(ntiter/10)
ANN$errc=1:nstep*0
ANN$errv=1:nstep*0
ANN$time<-as.numeric(rownames(data))
n<-nrow(data)
m<-ncol(data)

if (!is.null(outfile))
	{
	fgraph=paste(outfile,".pdf",sep="")
	ftext=paste(outfile,".txt",sep="")
	sink(file=ftext)
	pdf(file=fgraph)
	}

# arrangement et standardization

varlag<-as.matrix(varlag)
p<-nrow(varlag)

xx<-matrix(NA,n,p)
coln=rep(NA,p)
n1=abs(min(varlag[,2]))
print(n1)
n2=max(varlag[,2])
print(n2)
if (n1>0) 
	{
	x1<-oatrix(NA,n1,m)
	rownames(x1)=paste("NA",1:n1,sep="")
	colnames(x1)=colnames(data) 
	} 
else 	{ x1=c() }
if (n2>0) 
	{
	x2<-matrix(NA,n2,m)
	rownames(x2)=paste("NA",1:n2,sep="")
	colnames(x2)=colnames(data) 
	}
else 	{ x2=c() }
x=rbind(x1,as.matrix(data),x2)
ivd=rep(1,m)
# regresseurs
for (k in 1:p)
	{
	ivd[varlag[k,1]]=0
	i1=n1+1+varlag[k,2]
	i2=n1+n+varlag[k,2]
	xx[,k]=x[i1:i2,varlag[k,1]]
	coln[k]=paste(colnames(data)[varlag[k,1]],varlag[k,2],sep="@")
	}
colnames(xx)=coln
rownames(xx)=rownames(data)
# variables dépendantes 
k1=0
y=c()
for (k in 1:m)
	{	
	if(ivd[k]==1)
		{
		k1=k1+1
		y=cbind(y,xx[,k])
		coln[k1]=colnames(xx)[k]
		}
	}
y=as.matrix(y)
colnames(y)=coln
rownames(y)=rownames(data)
mvd<-ncol(y)
ncal<-n*2/3
xmin<-apply(xx,2,min,na.rm=TRUE)
xmax<-apply(xx,2,max,na.rm=TRUE)
ymin<-apply(y,2,min,na.rm=TRUE)
ymax<-apply(y,2,max,na.rm=TRUE)
print(ivd)
print(xmin)
print(ymin)
xx<-scale(x,center=xmin,scale=(xmax-xmin))
yy<-scale(y,center=ymin,scale=(ymax-ymin))
# tirage au sort pour constituer un échantillon de calibration et un de vérification
samp <- sample(1:n,n)
sampcal<-samp[1:ncal]
sampver<-samp[(ncal+1):n]
xxcal=xx[sampcal,]
xxver=xx[sampver,]
yycal=yy[sampcal,]
yyver=yy[sampver,]
ANN$r2c<-rep(0,mvd)
ANN$r2v<-rep(0,mvd)
layout(matrix(1:4,2,2))
# initialisation calibration
dd.nn <- nnet(xxcal, yycal, size = k1, decay = 0, maxit = 1, trace=FALSE) 
# suite calibration
for (niter in 1:nstep) 
	{ 
	dd.nn <- nnet(xxcal, yycal, size = k1, decay = 0, maxit = 10, Wts=dd.nn$wts,trace=FALSE) 
	zcal<-predict(dd.nn,xxcal,type="raw")
	plot(c(zcal),c(as.matrix(yycal)), type='p',xlab='pred', ylab='obs', main='Calibration')
	zver<-predict(dd.nn,xxver,type="raw")
	plot(c(zver),c(as.matrix(yyver)), type='p',xlab='pred', ylab='obs', main='Verification')
	ANN$errv[niter]<-mean(sd(zver-yyver)^2/sd(yyver)^2)
	ANN$errc[niter]<-mean(sd(zcal-yycal)^2/sd(yycal)^2)
	plot(iter[1:niter],ANN$errc[1:niter],type='l', xlab='Iteration', ylab='error',main='Calibration',log="y")
	plot(iter[1:niter],ANN$errv[1:niter],type='l', xlab='Iteration', ylab='error',main='Verification',log="y")
	} 
# graphique final
layout(matrix(1:3,3,1))
ANN$y<-as.matrix(predict(dd.nn,xx,type="raw"))*(ymax[j]-ymin[j])+ymin[j]
for (j in 1:mvd) 
	{
	plot(time,y[,j], type='p',xlab='time', ylab='obs/pred',main=colnames(y)[j])
	lines(time,ANN$y[,j],col="red")
	ANN$r2c[j]=1-mean((y[sampcal,j]-ANN$y[sampcal,j])^2)/var(y[sampcal,j])
	ANN$r2v[j]=1-mean((y[sampver,j]-ANN$y[sampver,j])^2)/var(y[sampver,j])
	}
if (!is.null(outfile))
	{
	sink(file=ftext,append=TRUE)
	cat("\nImpression de la liste ANN\n")
	print(ANN)
	dev.off()
	sink()
	}
return()
}
