cospecfft <-
function(x,outfile=NULL)
{
#initialisation
xobsname<-rownames(x)
nx<-nrow(x)
mx<-ncol(x)
if (!is.null(outfile)) 
	{
	fgraph=paste(outfile,".pdf",sep="")
	ftext=paste(outfile,".txt",sep="")
	sink(file=ftext)
	pdf(file=fgraph)
	}

# mean and standard deviation

xmean<-apply(x,2,mean)
xstd<-apply(x,2,sd)
cat("Co-spectrum analysis of multivariate data using FFT","\n")
cat("Summary statistics of data : ","\n")
print(summary(x))
op<-par(cex=0.01,cex.main=1.3,cex.axis=1.2,cex.lab=1.3,mfrow=c(1,1))
CS<-list(title="FFT co-spectrum of a multivariate time-series")
# cospectral analysis
cx<-spec.pgram(x,spans=c(3,5),plot=TRUE)
CS$freq<-cx$freq
CS$spec<-cx$spec
CS$df<-cx$df
CS$bandwidth<-cx$bandwidth
CS$spec=as.matrix(CS$spec)
rownames(CS$spec)<-signif(cx$freq,6)
if (mx>1) {
	CS$coh<-cx$coh
	CS$phase<-cx$phase
	rownames(CS$coh)<-signif(cx$freq,6)
	rownames(CS$phase)<-signif(cx$freq,6)
}
colnames(CS$spec)<-colnames(x)
print(CS)
# loop on the variables pairs
op<-par(cex=0.01,cex.main=1.3,cex.axis=1.2,cex.lab=1.3,mfrow=c(3,1),mai=c(0.4,0.6,0.2,0.2))
kgraph<-0
if (mx>1) {
	for (j in 2:mx)
        {
        for (k in 1:(j-1))
                {
                tit<-paste(colnames(x)[j]," / ",colnames(x)[k])
                kgraph <- kgraph+1
                gmin<-min(cx$spec)
                gmax<-max(cx$spec)
                plot(cx$freq,cx$spec[,j],type="l",xlab="",ylab="density",main=tit,ylim=c(gmin,gmax),log='y')
                lines(cx$freq,cx$spec[,k],col='red')
                plot(cx$freq,cx$coh[,j-1+(k-1)*(k-2)/2],type="l",xlab="",ylab="coherency",main="")
                plot(cx$freq,cx$phase[,j-1+(k-1)*(k-2)/2],type="l",xlab="frequency",ylab="phase",main="")
                }
        }
}

par(op)
if (!is.null(outfile)) 
	{
	sink(file=ftext,append=TRUE)
	cat("\nImpression de la liste RFcpb\n")
	print(CS)
	dev.off()
	sink()
	sink()
	sink()
	}
return(CS)
}
