nnsens <-
function(wts,dmin,dmax,varname,isim,totsim,resp) {
# read data
num<-0:20
n<-nrow(as.matrix(num))
mr<-wts$n[1]
p<-wts$n[3]
x1<-matrix(0.5,nr=n,nc=mr)
x2<-matrix(num,nr=n,nc=mr)/20
if (isim==1) {
	titre="response function of a bootstrap ANN"
	input<-matrix(0,n,mr)
	output<-array(0,c(n,mr,p,totsim))
} else {
	titre=resp$title
	input=resp$x
	output=resp$y
}

for (j in 1:mr) {
	x<-x1
	x[,j]<-x2[,j]
	z<-as.matrix(predict(wts,x,type="raw"))
	input[,j]<-x[,j]*(dmax[j]-dmin[j])+dmin[j]
	for (k in 1:p) {
		output[,j,k,isim]<-z[,k]*(dmax[mr+k]-dmin[mr+k])+dmin[mr+k]
		if (isim==totsim) {
			z3<-apply(output[,j,k,],1,quantile,probs=c(0.025, 0.5, 0.975))
			plot(input[,j],z3[2,],type="l",xlab=varname[j], ylab=varname[mr+k], ylim=c(dmin[mr+k],dmax[mr+k]), main="Response function")
			polygon(c(input[,j],rev(input[,j])),c(z3[1,],rev(z3[3,])),col="gray",border=FALSE)
			lines(input[,j],z3[2,])
		}
	}
}
list(title=titre,x=input,y=output)
}
