pca <-
function(matname,p=0,outfile=NULL)
# principal component analysis of data matrix matname
# we retain p components
{
# initialisation

if (!is.null(outfile))
	{
	fgraph=paste(outfile,".pdf",sep="")
	ftext=paste(outfile,".txt",sep="")
	sink(file=ftext)
	pdf(file=fgraph)
	}

cat("PRINCIPAL COMPONENTS ANALYSIS : princomp method\n")
cat("--------------------------------------------------------------\n")

n<-nrow(matname)
m<-ncol(matname)
dimmat<-list(n,m)
if (p==0) {p=m}

# principal component analysis, cration de la matrice des scores

pc<-princomp(matname,cor=TRUE)

# dessin des valeurs propres dans la sous-fenetre (1,1)

screeplot(pc, npcs=m, type="barplot",main="Screeplot of the eignevalues") 
biplot(pc)

# dessin des scores 1 dans la 2e bande

timelabel<-as.numeric(colnames(matname))
if(max(is.na(timelabel))==1) {timelabel<-1:n}
op<-par(cex=0.01,cex.main=1.3,cex.axis=1.2,cex.lab=1.3,mai=c(0.3,0.7,0.1,0.1))
layout(matrix(1:3,3,1))
plot(timelabel,pc$scores[, 1],type='l',main="",ylab="1st PC scores",xlab="")
plot(timelabel,pc$scores[, 2],type='l',main="",ylab="2nd PC scores",xlab="")
plot(timelabel,pc$scores[, 3],type='l',main="",ylab="3rd PC scores",xlab="")
 

# Output text_file

cat("\n\tMATRIX DIMENSIONS\nnrow:",nrow(matname), "\tncol:",ncol(matname))
cat("\n\tSummary statistics of data:\n")
print(summary(matname))
cat("\n\tPrincipal component: ")
cat(100*pc$sdev[1:p]/m,"\n")
cat("\n\tStandard deviation (pc$sdev): \n")
print(pc$sdev)
print(pc$loadings)
cat("\n\tCenter (pc$center) :\n")
print(pc$center)
cat("\n\tScale (pc$scale) :\n")
print(pc$scale)
cat("\n\tObservation number (pc$n.obs): ")
print(pc$n.obs)
cat("\n\tPrincipal component scores (pc$scores):\n")
print(colnames(pc$scores)[1:p])
for (i in 1:n) {
	cat(rownames(matname)[i],pc$scores[i,1:p])
	cat("\n")		
	}
# fin
if (!is.null(outfile)) {
	sink()
	dev.off()
}
return(pc)
}
