plot.wt <-
function(wt,phs,t,s0,noctave,w0,cv=0,markt=-999,marks=-999,logscale=FALSE,phase=FALSE,units="",plottitle="Wavelet Plot",device="screen",file="wavelet",split=FALSE,color=TRUE)
	{
	ncolors <- 64
	colors <- wtcolors(ncolors)
	if (color==FALSE) { colors <- gray((0:ncolors)/ncolors*0.7+0.3) }
	rangev <- (0:(ncolors-1))/(ncolors-1)
	rangebar <- matrix(rangev,nrow=2,ncol=64,byrow=TRUE) 
   	s <- 2^(0:(noctave))*s0
	sn <- (0:(noctave))/noctave
  #----------------
  # Setting layout
  #----------------
	if (device=="ps" && split==FALSE)
		{
		if (file != "samefile") {
			file <- paste(file,".pdf",sep="")
#		postscript(file,onefile=FALSE,horizontal=TRUE,paper="a4")
			pdf(file,width = 10, height = 8)
			cat(paste("# writing",file," \n"))
			print(logscale)
			}
		}
	if (device=="ps" && split==TRUE)
		{
		file1 <- paste(file,".mod.eps",sep="")
		postscript(file1,onefile=TRUE,horizontal=TRUE,paper="special",width=12,height=5)
		cat(paste("# writing",file," \n"))
  		}
  		if (phase==TRUE && split==FALSE) { nlo <- layout(matrix(c(1,2,3,4),2,2,byrow=TRUE),widths=c(4,1)) }
		else { nlo <- layout(matrix(c(1,2),ncol=2,byrow=TRUE),widths=c(5,1)) }
		op<-par(mai=c(0.5,0.5,0.5,0.5),cex=1)
  #-----------------
  # Plotting modulus
  #-----------------
	if (logscale)
		{
    		if (units=="") { image(x=t,z=log10(wt),col = colors,axes=FALSE,xlab="Time",ylab="Scale",frame.plot=TRUE) }
    		else { image(x=t,z=log10(wt),col = colors,axes=FALSE,xlab=paste("Time ","[",units,"]",sep=""),ylab=paste("Scale ","[",units,"]",sep=""),frame.plot=TRUE) }
		}
	else
		{
    		if (units=="") { image(x=t,z=wt,col = colors,axes=FALSE,xlab="Time",ylab="Scale",frame.plot=TRUE) }
    		else { image(x=t,z=wt,col = colors,axes=FALSE,xlab=paste("Time ","[",units,"]",sep=""),ylab=paste("Scale ","[",units,"]",sep=""),frame.plot=TRUE) }
		}
		if (length(dim(cv))==0)
		{                		#Critical values
		if (cv[1]!=0 & cv[1]!=-1) { plot.cv(t,wt,cv) }
  		else { plot.cv(t,wt,cv) }
		}
	plot.coi(t,s0,noctave,w0)		#cone of influence
	plot.marks(t,s0,noctave,markt,marks)   	#additional guiding lines
  	axis(side=1,at=axTicks(1))
	axis(side=2,sn,labels=as.character(s))
	title(main=plottitle)
	image(z=rangebar,axes=FALSE,col=colors,frame.plot=TRUE)
	if (length(dim(cv))==0) { for (i in 1:length(cv)) { if (cv[i]!=0) { lines(c(-1,2),c(cv[i],cv[i])) } } }
	if (!logscale) { axis(side=2,(0:5)/5,labels=c("0","","","","","1")) }
  	else
		{
		labelv <- substr(as.character(c(0:5)*(max(log10(wt),na.rm=TRUE)-min(log10(wt),na.rm=TRUE))/5),1,4)
    		axis(side=2,(0:5)/5,labels=labelv)
  		}
  #-----------------
  # Plotting phase
  #-----------------  
	if (phase==TRUE)
		{
    		if (device=="ps" && split==TRUE)
			{
			dev.off()
      			file2 <- paste(file,".phs.eps",sep="")
     			postscript(file2,onefile=TRUE,horizontal=TRUE,paper="special",width=10,height=5)
      			cat(paste("# writing",file2," \n"))
    			}
		colors <- rainbow(ncolors)
    	if (color==FALSE)
		{
      		dummy <- gray((0:ncolors)/ncolors)
      		colors[1:(ncolors/2)] <- dummy[(ncolors/2+1):ncolors]
      		colors[(ncolors/2+1):ncolors] <- dummy[1:(ncolors/2)]
    		}
	if (units=="") { 
image(x=t,z=phs,col=colors,axes=FALSE,xlab="Time",ylab="Scale",frame.plot=TRUE) }   
	else { image(x=t,z=phs,col=colors,axes=FALSE,xlab=paste("Time ","[",units,"]",sep=""),ylab=paste("Scale ","[",units,"]",sep=""),frame.plot=TRUE) }
	if (cv[1]!=0 & cv[1]!=-1) { plot.cv(t,wt,cv) }
	plot.coi(t,s0,noctave,w0)
	plot.marks(t,s0,noctave,markt,marks)
	axis(side=1,at=axTicks(1))
	axis(side=2,sn,labels=as.character(s))
	title(main="Phase")
	image(z=rangebar,axes=FALSE,col=colors,frame.plot=TRUE)
	axis(side=2,(0:4)/4,labels=c("-PI","","0","","PI"))
	} 
  	if (device=="ps") { dev.off() }
 	par(op) 
	}
