\name{MISmat}
\alias{MISmat}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Missing data reconstruction by modern analogues method}
\description{
 This function fills missing values in a matrix so that standard transfer function methods can be applied
}
\usage{
output=MISmat(dser,ichd=0,missing=NA,outfile=NULL)
}
\arguments{
  \item{dser}{ \code{dser} is the matrix of the tree-ring series }
  \item{ichd}{ \code{ichd} is option for the distance (0=euclidian /1=chord /2=log /3=canberra) (default = 0) }
  \item{missing}{ \code{missing} is the code for missing values (default=NA) }
  \item{outfile}{ \code{outfile} is the filename for the log and graphics }

}
\details{
For each raw of the dser matrix, this function calculate the distance with all the other raws; these distances are sorted by increased order and the kana first ones are used as analogues (kana being determined with monte-carlo test); each value of the raw is estimated as a weighted average of the corresponding value in the analogue vectors; if this value is really missing, the estimate is kept to fill the gap, if not, it is used for verification. The function returns a matrix where the missing values are replaced by the estimates. Several statistics are given to check the quality of the estimates.
}
\value{
  output MISmat list contains: 
  - estim, the matrix with all the estimates, including the lower and upper bar (in fact min and max of the analogues retained) 
  - misnumber, the vector of number of missing values per column
  - nbanal, the matrix of number analogues per raw and column (same dimension than dser)
  - mindist, the matrix of minimal distance of the analogues per raw and column (same dimension than dser)
  - maxdist, the matrix of maximal distance of the analogues per raw and column (same dimension than dser)
  - rmse, vector of the rmse (root mean square error), one per column of dser
  - R2, vector of the R2 (determination coefficient), one per column of dser
}
\references{ ~ ~ }
\author{ J. Guiot }
\note{ void
}
\examples{
output=MISmat(proxyeur,ichd=0)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ analogues}
\keyword{ euclidian distance} 
\keyword{ similarities}
\keyword{ weighted average }

