\name{cospecfft}
\alias{cospecfft}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ calculates FFT co-spectrum of a multivariate time-series }
\description{
  Transform the x matrix (m time-series) into a co-spectrum using the spec.pdgram function of library(stats)   
}
\usage{
  output=cospecfft(x,outfile=NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ \code{x} is the input matrix, dim (n,m) }
  \item{outfile}{ \code{outfile} is the filename for the log and graphics}
}
\details{
  The raw periodogram is not a consistent estimator of the spectral density, but adjacent values are asymptotically independent. Hence a consistent estimator can be derived by smoothing the raw periodogram, assuming that the spectral density is smooth. The series will be automatically padded with zeros until the series length is a highly composite number in order to help the Fast Fourier Transform. This is controlled by the fast and not the pad argument. The periodogram at zero is in theory zero as the mean of the series is removed (but this may be affected by tapering): it is replaced by an interpolation of adjacent values during smoothing, and no value is returned for that frequency.
  The function provides graphical output of cospectra by pairs (densities, coherency and phasis)
}
\value{
  output is a list CS of components
    CS$spec is the matrix of the individual spectra (m col)
    CS$coh is the matrix of the pairwise coherencies (m*(m-1) values)
    CS$phase is the matrix of the pairwise phases (m*(m-1) values)
    PFTdf = The distribution of the spectral density estimate can be approximated by a (scaled) chi square distribution with df degrees of freedom.
    PFT$bandwidth=The equivalent bandwidth of the kernel smoother as defined by Bloomfield (1976, page 201).
}
\references{ Bloomfield, P. (1976) Fourier Analysis of Time Series: An Introduction. Wiley. }
\author{ J. Guiot }
\note{ void
}
\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
\examples{
  cs=cospecfft(globclim,outfile="test")
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ time-series analysis }
\keyword{ spectral analysis }
\keyword{ fast fourier transform }