\name{recGAM}
\alias{recGAM}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ transfer function using the GAM method }
\description{
  calculate a generalized additive model (GAM) between environmental variables and principal components of the assemblages; regression coefficients are used for prediction.
}
\usage{
output=recGAM(xmat,ymat,xnewmat,ynewmat=FALSE,p=1,outfile=NULL)
}
\arguments{
  \item{xmat}{ \code{xmat} is the matrix of the predictors (assemblages) }
  \item{ymat}{ \code{ymat} is the matrix of the predictands (environment) }
  \item{xnewmat}{ \code{xnewmat} is the assemblages matrix  for verification or prediction }
  \item{ynewmat}{ \code{ynewmat} is the environmental matrix corresponding to xnewmat, if verification is wanted; if it is a prediction (reconstruction), assign to FALSE }
  \item{p}{ \code{p} is the number of principal components used; default = 1}
  \item{outfile}{ \code{outfile} is the filename for the log and graphics }
}
\details{
    The script uses "gam" of library "mgcv" for GAM modelling and "prcomp" for the principal components. Each environmental variable is processed independently. A maximum of 6 principal components is used; they are transformed by a spline function (to introduce non-linearity) and the environmental variables are regressed on them }
\value{
output list contains: 
  rmse, r2, calculated on the calibration data; 
  clim, the estimates (with 95% confidence intreval) of the predictands used for calibration;
  fclim the estimates of the new environmental matrix; 
  if there is verification, it contains also: 
    rmsep, RE (or r2p) and CE (calculated on the independent data). 
  RE is the variance explained as compared with the calibration average and CE is the variance explained as compared with the verification average.
}
\references{ ~ ~ }
\author{ J. Guiot }
\note{ void }
\examples{
output=recGAM(ss700po,ss700cl,fospo%,p=5)
}

\keyword{ multivariate statistics} 
\keyword{ non linear regression}
\keyword{ principal components}
\keyword{ transfer function}
\keyword{ GAM }
\keyword{ non parametric statistics}

