\name{respSURF}
\alias{respSURF}
\title{ 4-dim response surface of the environmental variables}
\description{
Calculate a response surface of each taxon to the first four environmental variables; if there is more than four environmental variables, the remaining ones are also calculated in function of the first four ones. New (virtual) assemblages are calculated at the nodes of the grid
}
\usage{
output=respSURF(xmat,ymat,nbgrid=10,outfile=NULL)
}
\arguments{
  \item{xmat}{ \code{xmat} is the matrix of the assemblages }
  \item{ymat}{ \code{ymat} is the matrix of the environmental variables }
  \item{nbgrid}{ \code{nbgrid} is the number of nodes to be used for each variables }
  \item{outfile}{ \code{outfile} is the filename for the log and graphics }
}
\details{
        The script uses "Tps" of library "fields" for fitting a surface to the first four environmental variables.
  It calculates virtual assemblages at the nbgrid^max(4,number of variables) nodes of the surface. The nodes which do not fall in the space covered by the initial data are removed.
  Pay attention that with 4 variables and 10 gridpoints, the maximum number of virtual assemblages is 10000.
  The results can be used vith recANA to produce response surface analogue method or revised analogue method.
}
\value{
output list contains: 
  r2, the % variance fitted by the surface for each environmental and assemblage variable
  totass, the matrix of original assemblages and virtual assemblages 
  totclim, the corresponding matrix of the environmental variables
}
\references{ ~ ~ }
\author{ J. Guiot }
\note{ void
}
\examples{
output=respSURF(ss700po,ss700cl,nbgrid=10)
}

\keyword{ multivariate statistics }
\keyword{ response surface }
\keyword{ field mapping }
\keyword{ RAM }
\keyword{ transfer function}

